#ifndef __WBT_H
#define __WBT_H

typedef struct WBT_node *WBT_ptr;

struct WBT_node
{
    SAMPLE_data_type data;
    WBT_ptr          left;
    WBT_ptr          right;
    int              weight;
};

/*-------------------------- Function Prototypes --------------------------*/

/* Internal */

WBT_ptr _WBT_alloc_node(SAMPLE_data_type data);
WBT_ptr _WBT_rotate_left(WBT_ptr p);
WBT_ptr _WBT_rotate_right(WBT_ptr p);
WBT_ptr _WBT_balance(WBT_ptr p, WBT_ptr parent);

/* External */

void    WBT_kill_tree(WBT_ptr p);
void    WBT_traverse(WBT_ptr p);
WBT_ptr WBT_search(WBT_ptr p,SAMPLE_data_type key);
WBT_ptr WBT_insert(WBT_ptr p,WBT_ptr parent,SAMPLE_data_type data);
WBT_ptr WBT_delete(WBT_ptr p,WBT_ptr parent,SAMPLE_data_type key);

#endif
